/*******************************************************************************
* File Name: ADC_DelSig_IRQ_intc.h
* Version 1.0
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright (2008), Cypress Semiconductor Corporation.
********************************************************************************
* This software is owned by Cypress Semiconductor Corporation (Cypress)
* and is protected by and subject to worldwide patent protection (United
* States and foreign), United States copyright laws and international treaty
* provisions. Cypress hereby grants to licensee a personal, non-exclusive,
* non-transferable license to copy, use, modify, create derivative works of,
* and compile the Cypress Source Code and derivative works for the sole
* purpose of creating custom software in support of licensee product to be
* used only in conjunction with a Cypress integrated circuit as specified in
* the applicable agreement. Any reproduction, modification, translation,
* compilation, or representation of this software except as specified above 
* is prohibited without the express, written permission of Cypress.
*******************************************************************************/
#if !defined(__ADC_DelSig_IRQ_INTC_H__)
#define __ADC_DelSig_IRQ_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>


/* Interrupt Controller API. */
void ADC_DelSig_IRQ_Start(void);
void ADC_DelSig_IRQ_Stop(void);

CY_ISR_PROTO(ADC_DelSig_IRQ_Interrupt);

void ADC_DelSig_IRQ_SetVector(cyisraddress address);
cyisraddress ADC_DelSig_IRQ_GetVector(void);

void ADC_DelSig_IRQ_SetPriority(uint8 priority);
uint8 ADC_DelSig_IRQ_GetPriority(void);

void ADC_DelSig_IRQ_Enable(void);
uint8 ADC_DelSig_IRQ_GetState(void);
void ADC_DelSig_IRQ_Disable(void);

void ADC_DelSig_IRQ_SetPending(void);
void ADC_DelSig_IRQ_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ADC_DelSig_IRQ ISR. */
#define ADC_DelSig_IRQ_INTC_VECTOR            ((reg16 *) ADC_DelSig_IRQ__INTC_VECT)

/* Address of the ADC_DelSig_IRQ ISR priority. */
#define ADC_DelSig_IRQ_INTC_PRIOR             ((reg8 *) ADC_DelSig_IRQ__INTC_PRIOR_REG)

/* Priority of the ADC_DelSig_IRQ interrupt. */
#define ADC_DelSig_IRQ_INTC_PRIOR_NUMBER      ADC_DelSig_IRQ__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ADC_DelSig_IRQ interrupt. */
#define ADC_DelSig_IRQ_INTC_SET_EN            ((reg8 *) ADC_DelSig_IRQ__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ADC_DelSig_IRQ interrupt. */
#define ADC_DelSig_IRQ_INTC_CLR_EN            ((reg8 *) ADC_DelSig_IRQ__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ADC_DelSig_IRQ interrupt state to pending. */
#define ADC_DelSig_IRQ_INTC_SET_PD            ((reg8 *) ADC_DelSig_IRQ__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ADC_DelSig_IRQ interrupt. */
#define ADC_DelSig_IRQ_INTC_CLR_PD            ((reg8 *) ADC_DelSig_IRQ__INTC_CLR_PD_REG)

/* __ADC_DelSig_IRQ_INTC_H__ */
#endif

