/*******************************************************************************
* File Name: ADC_DelSig_ISR_intc.h
* Version GetMajorVersion().GetMinorVersion()
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright (2008), Cypress Semiconductor Corporation.
********************************************************************************
* This software is owned by Cypress Semiconductor Corporation (Cypress)
* and is protected by and subject to worldwide patent protection (United
* States and foreign), United States copyright laws and international treaty
* provisions. Cypress hereby grants to licensee a personal, non-exclusive,
* non-transferable license to copy, use, modify, create derivative works of,
* and compile the Cypress Source Code and derivative works for the sole
* purpose of creating custom software in support of licensee product to be
* used only in conjunction with a Cypress integrated circuit as specified in
* the applicable agreement. Any reproduction, modification, translation,
* compilation, or representation of this software except as specified above 
* is prohibited without the express, written permission of Cypress.
*******************************************************************************/
#if !defined(__ADC_DelSig_ISR_INTC_H__)
#define __ADC_DelSig_ISR_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>





/* Interrupt Controller API. */
void ADC_DelSig_ISR_Start(void);
void ADC_DelSig_ISR_Stop(void);

CY_ISR_PROTO(ADC_DelSig_ISR_Interrupt);

void ADC_DelSig_ISR_SetVector(cyisraddress address);
cyisraddress ADC_DelSig_ISR_GetVector(void);

void ADC_DelSig_ISR_SetPriority(uint8 priority);
uint8 ADC_DelSig_ISR_GetPriority(void);

void ADC_DelSig_ISR_Enable(void);
uint8 ADC_DelSig_ISR_GetState(void);
void ADC_DelSig_ISR_Disable(void);

void ADC_DelSig_ISR_SetPending(void);
void ADC_DelSig_ISR_ClearPending(void);





/* __ADC_DelSig_ISR_INTC_H__ */
#endif

