/*******************************************************************************
* File Name: SPIM_InternalInterrupt_intc.h
* Version 1.0
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright (2008), Cypress Semiconductor Corporation.
********************************************************************************
* This software is owned by Cypress Semiconductor Corporation (Cypress)
* and is protected by and subject to worldwide patent protection (United
* States and foreign), United States copyright laws and international treaty
* provisions. Cypress hereby grants to licensee a personal, non-exclusive,
* non-transferable license to copy, use, modify, create derivative works of,
* and compile the Cypress Source Code and derivative works for the sole
* purpose of creating custom software in support of licensee product to be
* used only in conjunction with a Cypress integrated circuit as specified in
* the applicable agreement. Any reproduction, modification, translation,
* compilation, or representation of this software except as specified above 
* is prohibited without the express, written permission of Cypress.
*******************************************************************************/
#if !defined(__SPIM_InternalInterrupt_INTC_H__)
#define __SPIM_InternalInterrupt_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>





/* Interrupt Controller API. */
void SPIM_InternalInterrupt_Start(void);
void SPIM_InternalInterrupt_Stop(void);

CY_ISR_PROTO(SPIM_InternalInterrupt_Interrupt);

void SPIM_InternalInterrupt_SetVector(cyisraddress address);
cyisraddress SPIM_InternalInterrupt_GetVector(void);

void SPIM_InternalInterrupt_SetPriority(uint8 priority);
uint8 SPIM_InternalInterrupt_GetPriority(void);

void SPIM_InternalInterrupt_Enable(void);
uint8 SPIM_InternalInterrupt_GetState(void);
void SPIM_InternalInterrupt_Disable(void);

void SPIM_InternalInterrupt_SetPending(void);
void SPIM_InternalInterrupt_ClearPending(void);





/* __SPIM_InternalInterrupt_INTC_H__ */
#endif

