/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 1.0 Production
*
* Description:
* This file contains device initialization code. This file is automatically
* generated by PSoC Creator.
*
********************************************************************************
* Copyright 2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void.
*
*
* Return:
*   void.
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}

/* This file contains the data used to initialize the device. */

#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__C51__) || defined(__CX51__)
#define CYCODE code
#define CYDATA data
#define CYXDATA xdata
#define CYFAR far
extern void cymemzero(void CYFAR *addr, uint16 size);
extern void cyconfigcpy(uint16 size, const void CYFAR *src, void CYFAR *dest) small;
extern void cyconfigcpycode(uint16 size, const void CYCODE *src, void CYFAR *dest);
#define CYMEMZERO(a,c) cymemzero((a),(c))
#define CYCONFIGCPY(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#define CYCODE
#define CYDATA
#define CYXDATA
#define CYFAR
#define CYMEMZERO(a,c) cymemset((a),0,(c))
#define CYCONFIGCPY(d,s,c) cymemcpy((d),(s),(c))
#define CYCONFIGCPYCODE(d,s,c) cymemcpy((d),(s),(c))
#endif

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
#define CYPACKED __attribute__ ((packed))
#define CYALIGNED __attribute__ ((aligned))
#if CYDEV_CONFIGURATION_DMA
#define DMAINITSEC __attribute__ ((section (".dma_init")))
#else
#define DMAINITSEC
#endif
#if defined(__ARMCC_VERSION)
#define CY_CFG_MEMORY_BARRIER() __memory_changed()
#else
#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
#endif
#else
/* Keil C51 and others */
#define CYPACKED
#define CYALIGNED
#define DMAINITSEC
#define CY_CFG_MEMORY_BARRIER()
#endif

typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;


#if defined(__C51__) || defined(__CX51__)
#define CYMEMZERO8(a,c) cymemzero((a),(c))
#define CYCONFIGCPY8(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE8(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemzero8(void *addr, unsigned int count)
{
	volatile uint8 *addr8 = (uint8 *)addr;
	while (count--)
	{
		*addr8 = 0;
		addr8++;
	}
}

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemcpy8(void *dest, const void *src, unsigned int count)
{
	volatile uint8 *dest8 = (uint8 *)dest;
	const uint8 *src8 = (const uint8 *)src;

	while (count--)
	{
		*dest8 = *src8;
		dest8++;
		src8++;
	}
}

#define CYMEMZERO8(a,c) cymemzero8((a),(c))
#define CYCONFIGCPY8(d,s,c) cymemcpy8((d),(s),(c))
#define CYCONFIGCPYCODE8(d,s,c) cymemcpy8((d),(s),(c))
#endif

#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_PRT1_DR), 16},
	{(void CYFAR *)(CYREG_PRT3_DR), 16},
	{(void CYFAR *)(CYREG_PRT6_DR), 16},
	{(void CYFAR *)(CYREG_PRT12_DR), 16},
	{(void CYFAR *)(CYREG_PRT15_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U1_BASE), 128},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_ROUTE_BASE + 0x00000080), 3712},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
};

const uint8 CYCODE cfg_byte_table[] = {
	0x15,
	0x00, 0x64, 0x02, /* Base address 0x006400 */
	/* CYDEV_UWRK_UWRK8_B0_BASE + 0x00000070 */
	0x80, 0x0F, 0x85, 0x07, 
	0x01, 0x00, 0x32, /* Base address 0x010000 */
	/* CYDEV_UCFG_B0_P0_U1_BASE */
	0x81, 0x0C, 0x83, 0x10, 0x85, 0x56, 0x87, 0x09, 0x88, 0xF9, 0x89, 0x02, 0x8A, 0x06, 0x8C, 0x33, 
	0x8D, 0x60, 0x90, 0x44, 0x91, 0x80, 0x92, 0xB1, 0x94, 0x51, 0x96, 0xA0, 0x97, 0x02, 0x98, 0x02, 
	0x99, 0x01, 0x9A, 0x31, 0x9C, 0x31, 0x9D, 0x07, 0x9E, 0x02, 0x9F, 0x38, 0xA0, 0x31, 0xA1, 0x02, 
	0xA2, 0x02, 0xA4, 0x16, 0xA5, 0x02, 0xA6, 0xC8, 0xA8, 0x02, 0xA9, 0x02, 0xAC, 0x33, 0xAD, 0x02, 
	0xB0, 0x0F, 0xB1, 0x7F, 0xB2, 0xE0, 0xB3, 0x08, 0xB5, 0x80, 0xB6, 0x16, 0xB7, 0x04, 0xB8, 0x20, 
	0xB9, 0x02, 0xBA, 0x0A, 0xBE, 0x10, 0xBF, 0x54, 0xD4, 0x09, 0xD8, 0x04, 0xD9, 0x04, 0xDB, 0x04, 
	0xDC, 0x11, 0xDD, 0x10, 
	0x01, 0x01, 0x17, /* Base address 0x010100 */
	/* CYDEV_UCFG_B0_P0_ROUTE_BASE + 0x00000080 */
	0x80, 0x0A, 0x81, 0x80, 0x84, 0x01, 0x8A, 0x02, 0x8B, 0x04, 0x8C, 0x90, 0x8D, 0x80, 0x8F, 0x80, 
	0x91, 0x04, 0xAD, 0x04, 0xC0, 0xCF, 0xC2, 0xF7, 0xC4, 0xFF, 0xCA, 0xFF, 0xCC, 0xFF, 0xCE, 0xFF, 
	0xD0, 0x0F, 0xD2, 0x08, 0xD6, 0xF0, 0xD8, 0x18, 0xE0, 0x10, 0xE2, 0x40, 0xE6, 0x04, 
	0x01, 0x02, 0x32, /* Base address 0x010200 */
	/* CYDEV_UCFG_B0_P1_U0_BASE */
	0x02, 0x80, 0x06, 0x20, 0x0E, 0x80, 0x0F, 0x01, 0x10, 0x40, 0x14, 0x0E, 0x18, 0x04, 0x1A, 0x39, 
	0x1F, 0x01, 0x20, 0x05, 0x22, 0x3A, 0x24, 0x13, 0x26, 0x04, 0x2A, 0x40, 0x2F, 0x01, 0x30, 0x80, 
	0x31, 0x01, 0x32, 0x0F, 0x34, 0x30, 0x36, 0x40, 0x38, 0x08, 0x3E, 0x41, 0x3F, 0x01, 0x40, 0x01, 
	0x41, 0x03, 0x45, 0x0E, 0x47, 0xCB, 0x48, 0x31, 0x49, 0xFF, 0x4A, 0xFF, 0x4B, 0xFF, 0x4C, 0x03, 
	0x4E, 0xF0, 0x4F, 0x04, 0x50, 0x08, 0x54, 0x41, 0x58, 0x04, 0x59, 0x04, 0x5A, 0x24, 0x5B, 0x04, 
	0x5C, 0x01, 0x5D, 0x08, 0x5F, 0x20, 0x60, 0x40, 0x61, 0x01, 0x62, 0xC0, 0x63, 0x01, 
	/* CYDEV_UCFG_B0_P1_U1_BASE */
	0xD4, 0x40, 0xDB, 0x04, 0xDD, 0x10, 
	0x01, 0x03, 0x47, /* Base address 0x010300 */
	/* CYDEV_UCFG_B0_P1_ROUTE_BASE */
	0x04, 0x86, 0x0D, 0x10, 0x0E, 0x20, 0x0F, 0x80, 0x14, 0x20, 0x15, 0x01, 0x16, 0x08, 0x1C, 0x84, 
	0x1D, 0x20, 0x1E, 0x21, 0x1F, 0x08, 0x27, 0x80, 0x2C, 0x10, 0x2D, 0x40, 0x2E, 0x04, 0x37, 0x40, 
	0x39, 0x20, 0x3B, 0x10, 0x3C, 0x10, 0x3E, 0x40, 0x3F, 0x10, 0x45, 0x84, 0x4E, 0x10, 0x56, 0x0A, 
	0x5A, 0x30, 0x5C, 0x08, 0x5E, 0x10, 0x5F, 0x80, 0x62, 0x50, 0x63, 0x20, 0x64, 0x10, 0x79, 0x01, 
	0x7A, 0x40, 0x7E, 0x20, 
	/* CYDEV_UCFG_B0_P1_ROUTE_BASE + 0x00000080 */
	0x80, 0x85, 0x84, 0x40, 0x86, 0x04, 0x89, 0x20, 0x8C, 0x48, 0x8F, 0x08, 0x90, 0x9A, 0x92, 0x40, 
	0x9A, 0x54, 0x9E, 0x80, 0x9F, 0x04, 0xA1, 0x01, 0xA2, 0x40, 0xA3, 0x94, 0xA7, 0x20, 0xA9, 0x41, 
	0xAA, 0x0A, 0xAF, 0x10, 0xB0, 0x50, 0xB1, 0x40, 0xB2, 0x05, 0xB3, 0x04, 0xB6, 0x04, 0xB7, 0x01, 
	0xC0, 0xB0, 0xC2, 0x70, 0xC4, 0x70, 0xCA, 0x10, 0xCC, 0x10, 0xCE, 0x10, 0xD0, 0x50, 0xD6, 0x70, 
	0xD8, 0x4E, 0xDE, 0x40, 0xE4, 0x04, 0xE6, 0x80, 0xEC, 0x02, 
	0x01, 0x04, 0x2D, /* Base address 0x010400 */
	/* CYDEV_UCFG_B0_P2_U0_BASE */
	0x54, 0x20, 0x5B, 0x04, 
	/* CYDEV_UCFG_B0_P2_U1_BASE */
	0x80, 0x02, 0x82, 0x01, 0x84, 0x03, 0x8B, 0x04, 0x8C, 0x03, 0x91, 0x02, 0x97, 0x08, 0x98, 0x03, 
	0xAB, 0x01, 0xAC, 0x02, 0xAE, 0x04, 0xB0, 0x01, 0xB1, 0x01, 0xB2, 0x04, 0xB3, 0x04, 0xB4, 0x01, 
	0xB5, 0x08, 0xB6, 0x02, 0xB7, 0x02, 0xBE, 0x41, 0xBF, 0x40, 0xC1, 0x06, 0xC2, 0x04, 0xC4, 0x05, 
	0xC5, 0xEC, 0xC8, 0x03, 0xC9, 0xFF, 0xCA, 0xFF, 0xCB, 0xFF, 0xCC, 0x22, 0xCE, 0xF0, 0xCF, 0x0F, 
	0xD0, 0x08, 0xD6, 0x02, 0xD7, 0x2C, 0xD8, 0x04, 0xD9, 0x04, 0xDA, 0x04, 0xDB, 0x04, 0xDD, 0x88, 
	0xDF, 0x20, 0xE0, 0x40, 0xE1, 0x01, 
	0x01, 0x05, 0x37, /* Base address 0x010500 */
	/* CYDEV_UCFG_B0_P2_ROUTE_BASE */
	0x04, 0x8A, 0x0E, 0x04, 0x16, 0x02, 0x1D, 0x82, 0x1F, 0x28, 0x24, 0x40, 0x25, 0x10, 0x26, 0x88, 
	0x27, 0x40, 0x2F, 0x08, 0x31, 0x04, 0x33, 0x04, 0x34, 0x02, 0x35, 0x08, 0x3D, 0x20, 0x45, 0x02, 
	0x4C, 0x08, 0x4D, 0x0A, 0x4F, 0x40, 0x58, 0x02, 0x59, 0x02, 0x61, 0x04, 0x62, 0x88, 0x63, 0x08, 
	0x64, 0x80, 0x6C, 0x45, 0x6E, 0x04, 0x7C, 0x08, 
	/* CYDEV_UCFG_B0_P2_ROUTE_BASE + 0x00000080 */
	0x92, 0x01, 0x94, 0x40, 0x98, 0x80, 0x9A, 0x02, 0x9F, 0x44, 0xA3, 0x04, 0xA5, 0x84, 0xA6, 0x20, 
	0xA7, 0x60, 0xB0, 0x28, 0xB2, 0x80, 0xB3, 0x80, 0xB4, 0x08, 0xB5, 0x41, 0xB6, 0x04, 0xC0, 0xB0, 
	0xC2, 0x40, 0xC4, 0x80, 0xCA, 0x20, 0xCC, 0xC0, 0xCE, 0x20, 0xD0, 0x80, 0xD2, 0x30, 0xD6, 0x01, 
	0xD8, 0x8E, 0xDE, 0x40, 0xE8, 0x04, 
	0x01, 0x07, 0x0B, /* Base address 0x010700 */
	/* CYDEV_UCFG_B0_P3_ROUTE_BASE + 0x00000080 */
	0x80, 0x08, 0x8C, 0x08, 0x92, 0x01, 0x97, 0x40, 0x9C, 0x08, 0xA4, 0x08, 0xA9, 0x04, 0xAB, 0x40, 
	0xB6, 0x20, 0xE0, 0x40, 0xE8, 0x10, 
	0x01, 0x0B, 0x03, /* Base address 0x010B00 */
	/* CYDEV_UCFG_B0_P5_ROUTE_BASE + 0x00000080 */
	0xB6, 0x80, 0xE8, 0x14, 0xEA, 0x40, 
	0x01, 0x0D, 0x03, /* Base address 0x010D00 */
	/* CYDEV_UCFG_B0_P6_ROUTE_BASE + 0x00000080 */
	0x82, 0x80, 0xE0, 0x10, 0xEC, 0x02, 
	0x01, 0x0F, 0x01, /* Base address 0x010F00 */
	/* CYDEV_UCFG_B0_P7_ROUTE_BASE + 0x00000080 */
	0xE6, 0x04, 
	0x01, 0x17, 0x03, /* Base address 0x011700 */
	/* CYDEV_UCFG_B1_P3_ROUTE_BASE + 0x00000080 */
	0xAF, 0x40, 0xB2, 0x01, 0xEE, 0x80, 
	0x01, 0x40, 0x0D, /* Base address 0x014000 */
	/* CYDEV_UCFG_DSI0_BASE */
	0x04, 0x90, 0x38, 0x80, 0x3B, 0x80, 0x78, 0x08, 0x7A, 0x40, 0x7C, 0x08, 0x7F, 0x40, 
	/* CYDEV_UCFG_DSI0_BASE + 0x00000080 */
	0x85, 0x10, 0x8C, 0x18, 0xA6, 0x40, 0xAE, 0x40, 0xE0, 0x40, 0xEC, 0x40, 
	0x01, 0x41, 0x02, /* Base address 0x014100 */
	/* CYDEV_UCFG_DSI1_BASE + 0x00000080 */
	0x88, 0x02, 0x95, 0x20, 
	0x01, 0x42, 0x03, /* Base address 0x014200 */
	/* CYDEV_UCFG_DSI2_BASE + 0x00000080 */
	0x95, 0x20, 0xA8, 0x02, 0xE8, 0x20, 
	0x01, 0x43, 0x0A, /* Base address 0x014300 */
	/* CYDEV_UCFG_DSI3_BASE + 0x00000080 */
	0x80, 0x20, 0x8C, 0x20, 0x95, 0x20, 0x9C, 0x80, 0xA5, 0x20, 0xA9, 0x20, 0xB4, 0x80, 0xC2, 0x10, 
	0xE0, 0x80, 0xE8, 0x20, 
	0x01, 0x44, 0x03, /* Base address 0x014400 */
	/* CYDEV_UCFG_DSI4_BASE */
	0x74, 0x04, 
	/* CYDEV_UCFG_DSI4_BASE + 0x00000080 */
	0x80, 0x08, 0xDE, 0x04, 
	0x01, 0x45, 0x0C, /* Base address 0x014500 */
	/* CYDEV_UCFG_DSI5_BASE */
	0x08, 0x08, 0x5B, 0x02, 0x5C, 0x02, 0x60, 0x04, 0x64, 0x02, 
	/* CYDEV_UCFG_DSI5_BASE + 0x00000080 */
	0x8C, 0x02, 0x9C, 0x08, 0xAC, 0x04, 0xC2, 0x08, 0xD6, 0x03, 0xD8, 0x02, 0xE0, 0x08, 
	0x01, 0x46, 0x03, /* Base address 0x014600 */
	/* CYDEV_UCFG_DSI6_BASE + 0x00000080 */
	0xA8, 0x04, 0xB7, 0x02, 0xE8, 0x08, 
	0x01, 0x48, 0x10, /* Base address 0x014800 */
	/* CYDEV_UCFG_DSI8_BASE */
	0x08, 0xA0, 0x0C, 0x20, 0x0D, 0x30, 0x0E, 0x80, 0x64, 0x04, 
	/* CYDEV_UCFG_DSI8_BASE + 0x00000080 */
	0x95, 0x20, 0x98, 0x04, 0x9C, 0xA0, 0xA4, 0x20, 0xA5, 0x20, 0xA6, 0x40, 0xAE, 0x40, 0xB0, 0x04, 
	0xC2, 0xE0, 0xD8, 0x80, 0xEC, 0x40, 
	0x01, 0x50, 0x03, /* Base address 0x015000 */
	/* CYREG_BCTL0_MDCLK_EN */
	0x00, 0x03, 0x08, 0x03, 0x0A, 0x01, 
};
/* BYTES: 828 */

/* UDB_1_5_0_CONFIG Address: CYDEV_UCFG_B0_P0_U0_BASE Size (bytes): 128 */
static const uint8 CYCODE BS_UDB_1_5_0_CONFIG_VAL[] DMAINITSEC = {
	0x00, 0x02, 0x01, 0x0D, 0x00, 0x49, 0x02, 0x06, 0x00, 0x80, 0x08, 0x00, 0x00, 0x80, 0x0C, 0x00, 
	0x00, 0x65, 0x00, 0x1A, 0x01, 0x80, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x01, 0x00, 0x00, 0x80, 
	0x01, 0x13, 0x00, 0x2C, 0x01, 0x80, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x40, 0x01, 0x00, 
	0x02, 0x80, 0x08, 0x70, 0x01, 0x70, 0x04, 0x0F, 0x00, 0x00, 0x00, 0xA8, 0x00, 0x00, 0x14, 0x01, 
	0x43, 0x01, 0x50, 0x00, 0x02, 0xEB, 0xFD, 0xDC, 0x3F, 0xFF, 0xFF, 0xFF, 0x22, 0x00, 0xF0, 0x08, 
	0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x20, 0x04, 0x04, 0x04, 0x04, 0x10, 0x11, 0x00, 0x00, 
	0x00, 0x00, 0xC0, 0x00, 0x40, 0x01, 0x10, 0x11, 0xC0, 0x01, 0x00, 0x01, 0x00, 0x00, 0x40, 0x01, 
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/* UDBSWITCH_1_5 Address: CYDEV_UCFG_B0_P0_ROUTE_BASE Size (bytes): 128 */
static const uint8 CYCODE BS_UDBSWITCH_1_5_VAL[] DMAINITSEC = {
	0x42, 0x00, 0x00, 0x24, 0x10, 0x00, 0x02, 0x00, 0x04, 0x10, 0x02, 0x00, 0x40, 0x10, 0xA0, 0x00, 
	0xA0, 0x00, 0x01, 0x20, 0x00, 0x04, 0x04, 0x81, 0xC2, 0x00, 0x40, 0x14, 0x20, 0x00, 0xA0, 0x92, 
	0x19, 0x00, 0x00, 0x40, 0x28, 0x81, 0x00, 0x00, 0x00, 0x04, 0xA0, 0x80, 0x22, 0x01, 0x00, 0x04, 
	0x10, 0x00, 0x44, 0x02, 0x81, 0x00, 0x08, 0x10, 0x05, 0x70, 0x00, 0x00, 0x2C, 0x80, 0x00, 0x02, 
	0x18, 0x00, 0x00, 0x82, 0x00, 0x00, 0x08, 0x10, 0x00, 0x00, 0x00, 0x46, 0x00, 0x00, 0x00, 0x00, 
	0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x04, 0x04, 0x00, 0x00, 0x82, 0x08, 0x10, 
	0x01, 0x00, 0x04, 0x10, 0x02, 0x02, 0x00, 0x40, 0x23, 0x21, 0x8A, 0x81, 0x00, 0x00, 0x00, 0x00, 
	0x80, 0x00, 0x26, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x08, 0x03, 0x00, 0x30, 0x00, 0x00};

/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_0_VAL[] DMAINITSEC = {
	0x00, 0xF0, 0xF0, 0x00, 0x00, 0x00, 0x04, 0x00};

/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] DMAINITSEC = {
	0x00, 0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_4 Address: CYREG_PRT4_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_4_VAL[] DMAINITSEC = {
	0x10, 0xE0, 0xE0, 0x00, 0xE0, 0x00, 0x00, 0x00};

/* IOPINS0_5 Address: CYREG_PRT5_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_5_VAL[] DMAINITSEC = {
	0xE0, 0x10, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00};

/* IOPORT_4 Address: CYDEV_PRTDSI_PRT4_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_4_VAL[] DMAINITSEC = {
	0x80, 0x40, 0x00, 0x00, 0x10, 0x00, 0x00};

/* IOPORT_5 Address: CYDEV_PRTDSI_PRT5_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_5_VAL[] DMAINITSEC = {
	0x10, 0x10, 0x00, 0x00, 0xE0, 0x00, 0x00};

/* CYDEV_CLKDIST_ACFG0_CFG0 Address: CYREG_CLKDIST_ACFG0_CFG0 Size (bytes): 4 */
static const uint8 CYCODE BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL[] DMAINITSEC = {
	0x95, 0x00, 0x18, 0x01};

#define CFG_MEMCPY_COUNT (sizeof(cfg_memcpy_list)/sizeof(*cfg_memcpy_list))
static const cfg_memcpy_t CYCODE cfg_memcpy_list [] = {
	/* dest, src, size */
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), BS_UDB_1_5_0_CONFIG_VAL, 128},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_ROUTE_BASE), BS_UDBSWITCH_1_5_VAL, 128},
};


#if defined(__C51__) || defined(__CX51__)
extern void cfg_write_bytes_code(void CYCODE *table);
extern void cfg_write_bytes(void CYFAR *table);
#else
/* For 32-bit little-endian architectures */
static void cfg_write_bytes32(void)
{
	unsigned int i, j = 0;
	for (i = 0; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = cy_cfg_addr_table[i];
		uint8 count = baseAddr & 0xFFu;
		baseAddr &= 0xFFFFFF00u;
		while (count--)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + cy_cfg_data_table[j].offset), cy_cfg_data_table[j].value);
			j++;
		}
	}
}
#endif

static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;

	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x1C0005);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x180005);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_CLKDIST_ACFG0_CFG0), (void CYCODE *)(BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL), 4);
	CY_SET_REG8((void CYXDATA *)(CYREG_SLOWCLK_ILO_CR0), 0x02);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x08);
	CY_SET_REG8((void CYXDATA *)(CYREG_FASTCLK_IMO_CR), 0x03);
	CY_SET_REG8((void CYXDATA *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8(CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x08);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	pllLock = 0;
	for (timeout = 14; *timeout_p && (pllLock != 0x03u); timeout--) { pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0)); }
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0103);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_LD), 0x02);

	CY_SET_REG8((void CYXDATA *)(CYREG_PM_ACT_CFG2), ((CY_GET_REG8(CYREG_PM_ACT_CFG2) | 0x03)));
	CY_SET_REG8((void CYXDATA *)(CYREG_PM_ACT_CFG1), ((CY_GET_REG8(CYREG_PM_ACT_CFG1) | 0x01)));
}

/* Analog API Functions */
void AnalogSetDefault(void)
{
	CY_SET_REG8(CYREG_PRT0_AG, 0x04);
	CY_SET_REG8(CYREG_PRT12_AG, 0xAA);
	CY_SET_REG8(CYREG_DSM0_SW0, 0x40);
	CY_SET_REG8(CYREG_PUMP_CR0, 0x44);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
uint8 CYXDATA * const CYCODE ADC_DelSig_AMux__addrTable[] = {
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
};

const uint8 CYCODE ADC_DelSig_AMux__maskTable[] = {
	0x40, 
	0x40, 
};

void ADC_DelSig_AMux_Set(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_AMux__addrTable[channel] |= ADC_DelSig_AMux__maskTable[channel];
}

void ADC_DelSig_AMux_Unset(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_AMux__addrTable[channel] &= ~ADC_DelSig_AMux__maskTable[channel];
}


/* This function is called by the start-up code for the selected device. */
void cyfitter_cfg(void)
{
	uint8 CYDATA i;

	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x50 : 0x40));
	CY_SET_REG8((void CYXDATA *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00);

	CY_SET_XTND_REG8(CYREG_MLOGIC_DBG_EN_DBG_EN, (CY_GET_XTND_REG8(CYREG_MLOGIC_DBG_EN_DBG_EN) | 0x01));
	for (i = 0; i < CFG_MEMSET_COUNT; i++)
	{
		const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
		CYMEMZERO(ms->address, ms->size);
	}

	for (i = 0; i < CFG_MEMCPY_COUNT; i++)
	{
		const cfg_memcpy_t CYCODE * CYDATA mc = &cfg_memcpy_list[i];
		void * CYDATA dest = mc->dest;
		const void CYCODE * CYDATA src = mc->src;
		uint16 CYDATA size = mc->size;
		CYCONFIGCPYCODE(dest, src, size);
	}

	cfg_write_bytes_code(cfg_byte_table);

	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), 7);
	CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), (void CYCODE *)(BS_IOPORT_4_VAL), 7);
	CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), (void CYCODE *)(BS_IOPORT_5_VAL), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7);
	/* BYTES WRITTEN: 62 */

	/* Enable digital routing */
	CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
	CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

	/* Enable UDB array */
	CY_SET_REG8(CYREG_PM_ACT_CFG0, CY_GET_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
	CY_SET_REG8(CYREG_PM_AVAIL_CR2, CY_GET_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);

	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (void CYCODE *)(BS_IOPINS0_0_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (void CYCODE *)(BS_IOPINS0_2_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT4_DM0), (void CYCODE *)(BS_IOPINS0_4_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT5_DM0), (void CYCODE *)(BS_IOPINS0_5_VAL), 8);
	CY_SET_REG8((void CYXDATA *)(CYREG_INTC_CLOCK_EN), 0x01);
	/* BYTES WRITTEN: 33 */

	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x10 : 0x00));
	ClockSetup();
	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x50 : 0x40));

	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 12);
	CY_SET_REG8(CYREG_PM_STBY_CFG0, CY_GET_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
