/*******************************************************************************
* File Name: MOSI_M.h  
* Version 1.20
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2009, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_MOSI_M_H) /* Pins MOSI_M_H */
#define CY_PINS_MOSI_M_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MOSI_M_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    MOSI_M_Write(uint8 value);
void    MOSI_M_SetDriveMode(uint8 mode);
uint8   MOSI_M_ReadDataReg(void);
uint8   MOSI_M_Read(void);
uint8   MOSI_M_ClearInterrupt(void);

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MOSI_M_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MOSI_M_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MOSI_M_DM_RES_UP          PIN_DM_RES_UP
#define MOSI_M_DM_RES_DWN         PIN_DM_RES_DWN
#define MOSI_M_DM_OD_LO           PIN_DM_OD_LO
#define MOSI_M_DM_OD_HI           PIN_DM_OD_HI
#define MOSI_M_DM_STRONG          PIN_DM_STRONG
#define MOSI_M_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MOSI_M_MASK               MOSI_M__MASK
#define MOSI_M_SHIFT              MOSI_M__SHIFT
#define MOSI_M_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MOSI_M_PS                     (* (reg8 *) MOSI_M__PS)
/* Data Register */
#define MOSI_M_DR                     (* (reg8 *) MOSI_M__DR)
/* Port Number */
#define MOSI_M_PRT_NUM                (* (reg8 *) MOSI_M__PRT) 
/* Connect to Analog Globals */                                                  
#define MOSI_M_AG                     (* (reg8 *) MOSI_M__AG)                       
/* Analog MUX bux enable */
#define MOSI_M_AMUX                   (* (reg8 *) MOSI_M__AMUX) 
/* Bidirectional Enable */                                                        
#define MOSI_M_BIE                    (* (reg8 *) MOSI_M__BIE)
/* Bit-mask for Aliased Register Access */
#define MOSI_M_BIT_MASK               (* (reg8 *) MOSI_M__BIT_MASK)
/* Bypass Enable */
#define MOSI_M_BYP                    (* (reg8 *) MOSI_M__BYP)
/* Port wide control signals */                                                   
#define MOSI_M_CTL                    (* (reg8 *) MOSI_M__CTL)
/* Drive Modes */
#define MOSI_M_DM0                    (* (reg8 *) MOSI_M__DM0) 
#define MOSI_M_DM1                    (* (reg8 *) MOSI_M__DM1)
#define MOSI_M_DM2                    (* (reg8 *) MOSI_M__DM2) 
/* Input Buffer Disable Override */
#define MOSI_M_INP_DIS                (* (reg8 *) MOSI_M__INP_DIS)
/* LCD Common or Segment Drive */
#define MOSI_M_LCD_COM_SEG            (* (reg8 *) MOSI_M__LCD_COM_SEG)
/* Enable Segment LCD */
#define MOSI_M_LCD_EN                 (* (reg8 *) MOSI_M__LCD_EN)
/* Slew Rate Control */
#define MOSI_M_SLW                    (* (reg8 *) MOSI_M__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MOSI_M_PRTDSI__CAPS_SEL       (* (reg8 *) MOSI_M__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MOSI_M_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MOSI_M__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MOSI_M_PRTDSI__OE_SEL0        (* (reg8 *) MOSI_M__PRTDSI__OE_SEL0) 
#define MOSI_M_PRTDSI__OE_SEL1        (* (reg8 *) MOSI_M__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MOSI_M_PRTDSI__OUT_SEL0       (* (reg8 *) MOSI_M__PRTDSI__OUT_SEL0) 
#define MOSI_M_PRTDSI__OUT_SEL1       (* (reg8 *) MOSI_M__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MOSI_M_PRTDSI__SYNC_OUT       (* (reg8 *) MOSI_M__PRTDSI__SYNC_OUT) 


#if defined(MOSI_M__INTSTAT)  /* Interrupt Registers */

    #define MOSI_M_INTSTAT                (* (reg8 *) MOSI_M__INTSTAT)
    #define MOSI_M_SNAP                   (* (reg8 *) MOSI_M__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MOSI_M_H */


/* [] END OF FILE */
