/*******************************************************************************
* File Name: Pin_MOSI_S.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_Pin_MOSI_S_H) /* Pins Pin_MOSI_S_H */
#define CY_PINS_Pin_MOSI_S_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_MOSI_S_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_MOSI_S_Write(uint8 value) ;
void    Pin_MOSI_S_SetDriveMode(uint8 mode) ;
uint8   Pin_MOSI_S_ReadDataReg(void) ;
uint8   Pin_MOSI_S_Read(void) ;
uint8   Pin_MOSI_S_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_MOSI_S_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_MOSI_S_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_MOSI_S_DM_RES_UP          PIN_DM_RES_UP
#define Pin_MOSI_S_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_MOSI_S_DM_OD_LO           PIN_DM_OD_LO
#define Pin_MOSI_S_DM_OD_HI           PIN_DM_OD_HI
#define Pin_MOSI_S_DM_STRONG          PIN_DM_STRONG
#define Pin_MOSI_S_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_MOSI_S_MASK               Pin_MOSI_S__MASK
#define Pin_MOSI_S_SHIFT              Pin_MOSI_S__SHIFT
#define Pin_MOSI_S_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_MOSI_S_PS                     (* (reg8 *) Pin_MOSI_S__PS)
/* Data Register */
#define Pin_MOSI_S_DR                     (* (reg8 *) Pin_MOSI_S__DR)
/* Port Number */
#define Pin_MOSI_S_PRT_NUM                (* (reg8 *) Pin_MOSI_S__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_MOSI_S_AG                     (* (reg8 *) Pin_MOSI_S__AG)                       
/* Analog MUX bux enable */
#define Pin_MOSI_S_AMUX                   (* (reg8 *) Pin_MOSI_S__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_MOSI_S_BIE                    (* (reg8 *) Pin_MOSI_S__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_MOSI_S_BIT_MASK               (* (reg8 *) Pin_MOSI_S__BIT_MASK)
/* Bypass Enable */
#define Pin_MOSI_S_BYP                    (* (reg8 *) Pin_MOSI_S__BYP)
/* Port wide control signals */                                                   
#define Pin_MOSI_S_CTL                    (* (reg8 *) Pin_MOSI_S__CTL)
/* Drive Modes */
#define Pin_MOSI_S_DM0                    (* (reg8 *) Pin_MOSI_S__DM0) 
#define Pin_MOSI_S_DM1                    (* (reg8 *) Pin_MOSI_S__DM1)
#define Pin_MOSI_S_DM2                    (* (reg8 *) Pin_MOSI_S__DM2) 
/* Input Buffer Disable Override */
#define Pin_MOSI_S_INP_DIS                (* (reg8 *) Pin_MOSI_S__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_MOSI_S_LCD_COM_SEG            (* (reg8 *) Pin_MOSI_S__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_MOSI_S_LCD_EN                 (* (reg8 *) Pin_MOSI_S__LCD_EN)
/* Slew Rate Control */
#define Pin_MOSI_S_SLW                    (* (reg8 *) Pin_MOSI_S__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_MOSI_S_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_MOSI_S__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_MOSI_S_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_MOSI_S__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_MOSI_S_PRTDSI__OE_SEL0        (* (reg8 *) Pin_MOSI_S__PRTDSI__OE_SEL0) 
#define Pin_MOSI_S_PRTDSI__OE_SEL1        (* (reg8 *) Pin_MOSI_S__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_MOSI_S_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_MOSI_S__PRTDSI__OUT_SEL0) 
#define Pin_MOSI_S_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_MOSI_S__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_MOSI_S_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_MOSI_S__PRTDSI__SYNC_OUT) 


#if defined(Pin_MOSI_S__INTSTAT)  /* Interrupt Registers */

    #define Pin_MOSI_S_INTSTAT                (* (reg8 *) Pin_MOSI_S__INTSTAT)
    #define Pin_MOSI_S_SNAP                   (* (reg8 *) Pin_MOSI_S__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_MOSI_S_H */


/* [] END OF FILE */
