/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 1.0 Production
*
* Description:
* This file contains device initialization code. This file is automatically
* generated by PSoC Creator.
*
********************************************************************************
* Copyright 2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void.
*
*
* Return:
*   void.
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}

/* This file contains the data used to initialize the device. */

#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__C51__) || defined(__CX51__)
#define CYCODE code
#define CYDATA data
#define CYXDATA xdata
#define CYFAR far
extern void cymemzero(void CYFAR *addr, uint16 size);
extern void cyconfigcpy(uint16 size, const void CYFAR *src, void CYFAR *dest) small;
extern void cyconfigcpycode(uint16 size, const void CYCODE *src, void CYFAR *dest);
#define CYMEMZERO(a,c) cymemzero((a),(c))
#define CYCONFIGCPY(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#define CYCODE
#define CYDATA
#define CYXDATA
#define CYFAR
#define CYMEMZERO(a,c) cymemset((a),0,(c))
#define CYCONFIGCPY(d,s,c) cymemcpy((d),(s),(c))
#define CYCONFIGCPYCODE(d,s,c) cymemcpy((d),(s),(c))
#endif

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
#define CYPACKED __attribute__ ((packed))
#define CYALIGNED __attribute__ ((aligned))
#if CYDEV_CONFIGURATION_DMA
#define DMAINITSEC __attribute__ ((section (".dma_init")))
#else
#define DMAINITSEC
#endif
#if defined(__ARMCC_VERSION)
#define CY_CFG_MEMORY_BARRIER() __memory_changed()
#else
#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
#endif
#else
/* Keil C51 and others */
#define CYPACKED
#define CYALIGNED
#define DMAINITSEC
#define CY_CFG_MEMORY_BARRIER()
#endif

typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;


#if defined(__C51__) || defined(__CX51__)
#define CYMEMZERO8(a,c) cymemzero((a),(c))
#define CYCONFIGCPY8(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE8(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemzero8(void *addr, unsigned int count)
{
	volatile uint8 *addr8 = (uint8 *)addr;
	while (count--)
	{
		*addr8 = 0;
		addr8++;
	}
}

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemcpy8(void *dest, const void *src, unsigned int count)
{
	volatile uint8 *dest8 = (uint8 *)dest;
	const uint8 *src8 = (const uint8 *)src;

	while (count--)
	{
		*dest8 = *src8;
		dest8++;
		src8++;
	}
}

#define CYMEMZERO8(a,c) cymemzero8((a),(c))
#define CYCONFIGCPY8(d,s,c) cymemcpy8((d),(s),(c))
#define CYCONFIGCPYCODE8(d,s,c) cymemcpy8((d),(s),(c))
#endif

#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_PRT1_DR), 16},
	{(void CYFAR *)(CYREG_PRT3_DR), 16},
	{(void CYFAR *)(CYREG_PRT6_DR), 16},
	{(void CYFAR *)(CYREG_PRT12_DR), 16},
	{(void CYFAR *)(CYREG_PRT15_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U1_BASE), 128},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_ROUTE_BASE + 0x00000080), 3712},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
};

#define CY_CFG_BASE_ADDR_COUNT 23
typedef struct
{
	uint8 offset;
	uint8 value;
} CYPACKED cy_cfg_addrvalue_t;

static const uint32 CYCODE cy_cfg_addr_table[] = {
	0x40006402u, /* Base address: 0x40006400 Count: 2 */
	0x40010032u, /* Base address: 0x40010000 Count: 50 */
	0x40010110u, /* Base address: 0x40010100 Count: 16 */
	0x40010232u, /* Base address: 0x40010200 Count: 50 */
	0x4001034Au, /* Base address: 0x40010300 Count: 74 */
	0x4001042Du, /* Base address: 0x40010400 Count: 45 */
	0x4001053Bu, /* Base address: 0x40010500 Count: 59 */
	0x40010706u, /* Base address: 0x40010700 Count: 6 */
	0x40010B05u, /* Base address: 0x40010B00 Count: 5 */
	0x40010D07u, /* Base address: 0x40010D00 Count: 7 */
	0x40010F02u, /* Base address: 0x40010F00 Count: 2 */
	0x40011502u, /* Base address: 0x40011500 Count: 2 */
	0x40011703u, /* Base address: 0x40011700 Count: 3 */
	0x40014002u, /* Base address: 0x40014000 Count: 2 */
	0x40014104u, /* Base address: 0x40014100 Count: 4 */
	0x40014206u, /* Base address: 0x40014200 Count: 6 */
	0x40014309u, /* Base address: 0x40014300 Count: 9 */
	0x40014402u, /* Base address: 0x40014400 Count: 2 */
	0x4001450Au, /* Base address: 0x40014500 Count: 10 */
	0x40014604u, /* Base address: 0x40014600 Count: 4 */
	0x4001480Eu, /* Base address: 0x40014800 Count: 14 */
	0x40014904u, /* Base address: 0x40014900 Count: 4 */
	0x40015004u, /* Base address: 0x40015000 Count: 4 */
};

static const cy_cfg_addrvalue_t CYCODE cy_cfg_data_table[] = {
	{0x80u, 0x0Fu},
	{0x85u, 0x07u},
	{0x80u, 0xF9u},
	{0x81u, 0x02u},
	{0x82u, 0x06u},
	{0x85u, 0x0Cu},
	{0x87u, 0x10u},
	{0x89u, 0x56u},
	{0x8Bu, 0x09u},
	{0x8Cu, 0x16u},
	{0x8Du, 0x02u},
	{0x8Eu, 0xC8u},
	{0x90u, 0x02u},
	{0x91u, 0x02u},
	{0x92u, 0x31u},
	{0x94u, 0x02u},
	{0x95u, 0x01u},
	{0x98u, 0x31u},
	{0x99u, 0x07u},
	{0x9Au, 0x02u},
	{0x9Bu, 0x38u},
	{0x9Cu, 0x31u},
	{0x9Eu, 0x02u},
	{0x9Fu, 0x02u},
	{0xA0u, 0x33u},
	{0xA1u, 0x02u},
	{0xA4u, 0x44u},
	{0xA5u, 0x02u},
	{0xA6u, 0xB1u},
	{0xA8u, 0x51u},
	{0xA9u, 0x80u},
	{0xAAu, 0xA0u},
	{0xACu, 0x33u},
	{0xADu, 0x60u},
	{0xB0u, 0xE0u},
	{0xB1u, 0x08u},
	{0xB2u, 0x0Fu},
	{0xB3u, 0x7Fu},
	{0xB5u, 0x04u},
	{0xB6u, 0x16u},
	{0xB7u, 0x80u},
	{0xB8u, 0x20u},
	{0xB9u, 0x08u},
	{0xBAu, 0x0Au},
	{0xBEu, 0x10u},
	{0xBFu, 0x51u},
	{0xD4u, 0x09u},
	{0xD8u, 0x04u},
	{0xD9u, 0x04u},
	{0xDBu, 0x04u},
	{0xDCu, 0x11u},
	{0xDDu, 0x10u},
	{0x80u, 0x40u},
	{0x89u, 0x80u},
	{0x8Au, 0x20u},
	{0x8Cu, 0x04u},
	{0x8Du, 0x11u},
	{0x8Eu, 0x80u},
	{0xC0u, 0x9Fu},
	{0xC2u, 0xFBu},
	{0xC4u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCCu, 0xFFu},
	{0xCEu, 0xFFu},
	{0xD0u, 0x0Bu},
	{0xD2u, 0x0Cu},
	{0xD6u, 0xF0u},
	{0xD8u, 0x14u},
	{0x02u, 0x80u},
	{0x04u, 0x05u},
	{0x06u, 0x3Au},
	{0x0Eu, 0x20u},
	{0x0Fu, 0x01u},
	{0x13u, 0x01u},
	{0x14u, 0x40u},
	{0x18u, 0x13u},
	{0x1Au, 0x04u},
	{0x22u, 0x80u},
	{0x24u, 0x0Eu},
	{0x2Au, 0x40u},
	{0x2Cu, 0x04u},
	{0x2Eu, 0x39u},
	{0x2Fu, 0x01u},
	{0x30u, 0x30u},
	{0x31u, 0x01u},
	{0x32u, 0x80u},
	{0x34u, 0x0Fu},
	{0x36u, 0x40u},
	{0x38u, 0x20u},
	{0x3Eu, 0x44u},
	{0x3Fu, 0x01u},
	{0x40u, 0x01u},
	{0x41u, 0x05u},
	{0x45u, 0x0Eu},
	{0x47u, 0xCBu},
	{0x48u, 0x31u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Cu, 0x03u},
	{0x4Eu, 0xF0u},
	{0x4Fu, 0x04u},
	{0x50u, 0x08u},
	{0x54u, 0x41u},
	{0x58u, 0x04u},
	{0x59u, 0x04u},
	{0x5Au, 0x24u},
	{0x5Bu, 0x04u},
	{0x5Cu, 0x01u},
	{0x5Du, 0x08u},
	{0x5Fu, 0x30u},
	{0x60u, 0x40u},
	{0x61u, 0x01u},
	{0x62u, 0xC0u},
	{0x63u, 0x01u},
	{0xD4u, 0x40u},
	{0xDBu, 0x04u},
	{0xDDu, 0x10u},
	{0x04u, 0x42u},
	{0x06u, 0x10u},
	{0x08u, 0x01u},
	{0x09u, 0x02u},
	{0x0Cu, 0x08u},
	{0x0Du, 0x10u},
	{0x14u, 0x40u},
	{0x15u, 0x40u},
	{0x16u, 0x04u},
	{0x17u, 0x08u},
	{0x1Cu, 0x40u},
	{0x1Du, 0x04u},
	{0x1Eu, 0x04u},
	{0x1Fu, 0x82u},
	{0x27u, 0x80u},
	{0x2Eu, 0x40u},
	{0x31u, 0x40u},
	{0x32u, 0x80u},
	{0x36u, 0x02u},
	{0x39u, 0x20u},
	{0x3Au, 0x20u},
	{0x3Fu, 0x80u},
	{0x45u, 0x80u},
	{0x4Cu, 0x02u},
	{0x4Eu, 0x10u},
	{0x56u, 0x06u},
	{0x5Au, 0x34u},
	{0x5Bu, 0x08u},
	{0x5Eu, 0x10u},
	{0x5Fu, 0x84u},
	{0x60u, 0x08u},
	{0x62u, 0x80u},
	{0x63u, 0x20u},
	{0x65u, 0x04u},
	{0x7Du, 0x02u},
	{0x85u, 0x42u},
	{0x86u, 0x04u},
	{0x87u, 0x04u},
	{0x88u, 0x41u},
	{0x8Cu, 0x08u},
	{0x8Fu, 0x01u},
	{0x90u, 0x02u},
	{0x92u, 0x40u},
	{0x93u, 0x02u},
	{0x96u, 0x80u},
	{0x97u, 0x08u},
	{0x9Au, 0x10u},
	{0xA0u, 0x01u},
	{0xA2u, 0xC4u},
	{0xA3u, 0x55u},
	{0xA4u, 0x04u},
	{0xA7u, 0x20u},
	{0xA8u, 0x08u},
	{0xA9u, 0x02u},
	{0xAFu, 0x50u},
	{0xB0u, 0x44u},
	{0xB1u, 0x10u},
	{0xB2u, 0x10u},
	{0xB4u, 0x08u},
	{0xB6u, 0x10u},
	{0xC0u, 0xB0u},
	{0xC2u, 0x60u},
	{0xC4u, 0xF0u},
	{0xCAu, 0x10u},
	{0xCCu, 0x80u},
	{0xCEu, 0x10u},
	{0xD0u, 0x10u},
	{0xD2u, 0x10u},
	{0xD6u, 0x70u},
	{0xD8u, 0x4Eu},
	{0xDEu, 0x80u},
	{0xE0u, 0x80u},
	{0xE8u, 0x48u},
	{0xECu, 0x82u},
	{0x54u, 0x20u},
	{0x5Bu, 0x04u},
	{0x88u, 0x03u},
	{0x8Bu, 0x04u},
	{0x8Cu, 0x03u},
	{0x91u, 0x02u},
	{0x94u, 0x03u},
	{0x97u, 0x08u},
	{0xA0u, 0x02u},
	{0xA2u, 0x01u},
	{0xABu, 0x01u},
	{0xACu, 0x02u},
	{0xAEu, 0x04u},
	{0xB0u, 0x01u},
	{0xB1u, 0x01u},
	{0xB2u, 0x04u},
	{0xB3u, 0x04u},
	{0xB4u, 0x01u},
	{0xB5u, 0x08u},
	{0xB6u, 0x02u},
	{0xB7u, 0x02u},
	{0xBEu, 0x41u},
	{0xBFu, 0x40u},
	{0xC1u, 0x05u},
	{0xC2u, 0x04u},
	{0xC4u, 0x03u},
	{0xC5u, 0xECu},
	{0xC8u, 0x03u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCCu, 0x22u},
	{0xCEu, 0xF0u},
	{0xCFu, 0x0Fu},
	{0xD0u, 0x08u},
	{0xD6u, 0x02u},
	{0xD7u, 0x28u},
	{0xD8u, 0x04u},
	{0xD9u, 0x04u},
	{0xDAu, 0x04u},
	{0xDBu, 0x04u},
	{0xDDu, 0x88u},
	{0xDFu, 0x10u},
	{0xE0u, 0x40u},
	{0xE1u, 0x01u},
	{0x04u, 0xA8u},
	{0x05u, 0x04u},
	{0x0Eu, 0x10u},
	{0x16u, 0x02u},
	{0x17u, 0x01u},
	{0x1Du, 0x82u},
	{0x1Fu, 0x28u},
	{0x25u, 0x10u},
	{0x26u, 0x8Au},
	{0x27u, 0x80u},
	{0x2Fu, 0x08u},
	{0x34u, 0x02u},
	{0x35u, 0x08u},
	{0x3Du, 0x20u},
	{0x44u, 0x10u},
	{0x45u, 0x02u},
	{0x4Cu, 0x01u},
	{0x4Du, 0x0Au},
	{0x58u, 0x02u},
	{0x59u, 0x02u},
	{0x61u, 0x04u},
	{0x62u, 0x88u},
	{0x63u, 0x08u},
	{0x66u, 0x08u},
	{0x6Cu, 0x50u},
	{0x6Eu, 0x10u},
	{0x6Fu, 0x01u},
	{0x7Cu, 0x20u},
	{0x8Cu, 0x01u},
	{0x94u, 0x08u},
	{0x97u, 0x04u},
	{0x9Au, 0x02u},
	{0xA2u, 0x40u},
	{0xA3u, 0x84u},
	{0xA4u, 0x08u},
	{0xA5u, 0x81u},
	{0xA6u, 0x02u},
	{0xA7u, 0x20u},
	{0xAAu, 0x04u},
	{0xAFu, 0x03u},
	{0xB0u, 0x25u},
	{0xB2u, 0x20u},
	{0xB4u, 0x26u},
	{0xB5u, 0x40u},
	{0xB6u, 0x40u},
	{0xC0u, 0xC0u},
	{0xC2u, 0x20u},
	{0xC4u, 0x90u},
	{0xCAu, 0x20u},
	{0xCCu, 0xC0u},
	{0xCEu, 0x20u},
	{0xD0u, 0xC0u},
	{0xD2u, 0x10u},
	{0xD6u, 0x01u},
	{0xD8u, 0x4Eu},
	{0xDEu, 0x20u},
	{0xE0u, 0x40u},
	{0xE8u, 0x08u},
	{0xECu, 0x44u},
	{0x9Cu, 0x30u},
	{0xA3u, 0x80u},
	{0xA9u, 0x01u},
	{0xACu, 0x08u},
	{0xAEu, 0x48u},
	{0xB3u, 0x84u},
	{0xB0u, 0x04u},
	{0xE8u, 0x08u},
	{0xEAu, 0x20u},
	{0xECu, 0x04u},
	{0xEEu, 0x80u},
	{0x98u, 0x04u},
	{0xACu, 0x04u},
	{0xB0u, 0x08u},
	{0xB4u, 0x08u},
	{0xE4u, 0x20u},
	{0xECu, 0x12u},
	{0xEEu, 0x20u},
	{0x88u, 0x04u},
	{0xE6u, 0x80u},
	{0xA8u, 0x20u},
	{0xAFu, 0x80u},
	{0x9Cu, 0x20u},
	{0xA3u, 0x80u},
	{0xACu, 0x10u},
	{0x80u, 0x01u},
	{0xE6u, 0x20u},
	{0x88u, 0x01u},
	{0x96u, 0x01u},
	{0xB2u, 0x01u},
	{0xB4u, 0x01u},
	{0x8Eu, 0x04u},
	{0x96u, 0x01u},
	{0xA5u, 0x20u},
	{0xACu, 0x01u},
	{0xB5u, 0x20u},
	{0xEEu, 0x10u},
	{0x96u, 0x01u},
	{0x97u, 0x04u},
	{0xA5u, 0xA0u},
	{0xA6u, 0x04u},
	{0xA9u, 0x80u},
	{0xAFu, 0x04u},
	{0xC2u, 0x10u},
	{0xE8u, 0x40u},
	{0xECu, 0x80u},
	{0x74u, 0x04u},
	{0xDEu, 0x04u},
	{0x0Bu, 0x20u},
	{0x58u, 0x01u},
	{0x5Du, 0x02u},
	{0x64u, 0x04u},
	{0x88u, 0x01u},
	{0xACu, 0x04u},
	{0xC2u, 0x08u},
	{0xD6u, 0x03u},
	{0xD8u, 0x01u},
	{0xE4u, 0x04u},
	{0xA9u, 0x02u},
	{0xACu, 0x04u},
	{0xB3u, 0x10u},
	{0xEAu, 0x04u},
	{0x09u, 0x80u},
	{0x0Bu, 0x02u},
	{0x0Du, 0x20u},
	{0x0Eu, 0x89u},
	{0x0Fu, 0x04u},
	{0x59u, 0x02u},
	{0x96u, 0x01u},
	{0x97u, 0x04u},
	{0xA5u, 0xA0u},
	{0xA6u, 0x44u},
	{0xAEu, 0x40u},
	{0xC2u, 0xE0u},
	{0xD6u, 0x40u},
	{0xECu, 0x40u},
	{0xABu, 0x01u},
	{0xADu, 0x02u},
	{0xECu, 0x20u},
	{0xEEu, 0x10u},
	{0x00u, 0x03u},
	{0x02u, 0x10u},
	{0x08u, 0x03u},
	{0x0Au, 0x01u},
};


/* UDB_1_5_0_CONFIG Address: CYDEV_UCFG_B0_P0_U0_BASE Size (bytes): 128 */
static const uint8 CYCODE BS_UDB_1_5_0_CONFIG_VAL[] DMAINITSEC = {
	0x01, 0x80, 0x00, 0x00, 0x00, 0x02, 0x02, 0x0D, 0x01, 0x80, 0x00, 0x00, 0x01, 0x00, 0x00, 0x80, 
	0x00, 0x80, 0x08, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x65, 0x01, 0x1A, 0x00, 0x49, 0x0C, 0x06, 
	0x01, 0x13, 0x00, 0x2C, 0x01, 0x80, 0x00, 0x00, 0x01, 0x40, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00, 
	0x04, 0x80, 0x08, 0x70, 0x01, 0x0F, 0x02, 0x70, 0x00, 0x00, 0x00, 0xA8, 0x00, 0x00, 0x14, 0x01, 
	0x31, 0x04, 0x50, 0x00, 0x06, 0xF0, 0xED, 0xBC, 0x3E, 0xFF, 0xFF, 0xFF, 0x22, 0x00, 0xF0, 0x08, 
	0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x24, 0x04, 0x04, 0x04, 0x04, 0x10, 0x11, 0x00, 0x00, 
	0x00, 0x00, 0xC0, 0x00, 0x40, 0x01, 0x10, 0x11, 0xC0, 0x01, 0x00, 0x01, 0x00, 0x00, 0x40, 0x01, 
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/* UDBSWITCH_1_5 Address: CYDEV_UCFG_B0_P0_ROUTE_BASE Size (bytes): 128 */
static const uint8 CYCODE BS_UDBSWITCH_1_5_VAL[] DMAINITSEC = {
	0x80, 0x00, 0x00, 0x64, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x82, 0x08, 0x20, 0x42, 0x20, 0x00, 
	0x28, 0x52, 0x02, 0x00, 0x18, 0x09, 0x02, 0x00, 0x02, 0x00, 0x42, 0x55, 0x40, 0x00, 0x10, 0xD0, 
	0x23, 0x20, 0x00, 0x40, 0x00, 0x10, 0x44, 0x80, 0x01, 0x04, 0x00, 0x88, 0x24, 0x00, 0x02, 0x02, 
	0x10, 0x82, 0x04, 0x00, 0x40, 0x00, 0x06, 0x10, 0x20, 0x81, 0x00, 0x04, 0x60, 0x05, 0x00, 0x00, 
	0x81, 0x84, 0x10, 0x00, 0x01, 0x00, 0x02, 0x40, 0x04, 0x00, 0x00, 0x42, 0x00, 0x00, 0x00, 0x00, 
	0x00, 0x00, 0xA8, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x80, 0xA0, 0x00, 0x1C, 0x24, 0x02, 0x20, 0x80, 
	0x00, 0x20, 0x00, 0x04, 0x00, 0x22, 0xA0, 0x40, 0x68, 0xC1, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0x14, 0x04, 0x02, 0x08, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0C, 0x08, 0x00, 0x04, 0x00, 0x20, 0x00};

/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_0_VAL[] DMAINITSEC = {
	0x00, 0xF0, 0xF0, 0x00, 0x00, 0x00, 0x04, 0x00};

/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] DMAINITSEC = {
	0x00, 0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_4 Address: CYREG_PRT4_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_4_VAL[] DMAINITSEC = {
	0x10, 0xE0, 0xE0, 0x00, 0xE0, 0x00, 0x00, 0x00};

/* IOPINS0_5 Address: CYREG_PRT5_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_5_VAL[] DMAINITSEC = {
	0xE0, 0x10, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00};

/* IOPORT_4 Address: CYDEV_PRTDSI_PRT4_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_4_VAL[] DMAINITSEC = {
	0x60, 0x40, 0x00, 0x00, 0x10, 0x00, 0x00};

/* IOPORT_5 Address: CYDEV_PRTDSI_PRT5_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_5_VAL[] DMAINITSEC = {
	0x00, 0x00, 0x00, 0x00, 0xE0, 0x00, 0x00};

/* CYDEV_CLKDIST_ACFG0_CFG0 Address: CYREG_CLKDIST_ACFG0_CFG0 Size (bytes): 4 */
static const uint8 CYCODE BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL[] DMAINITSEC = {
	0x95, 0x00, 0x18, 0x01};

#define CFG_MEMCPY_COUNT (sizeof(cfg_memcpy_list)/sizeof(*cfg_memcpy_list))
static const cfg_memcpy_t CYCODE cfg_memcpy_list [] = {
	/* dest, src, size */
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), BS_UDB_1_5_0_CONFIG_VAL, 128},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_ROUTE_BASE), BS_UDBSWITCH_1_5_VAL, 128},
};


#if defined(__C51__) || defined(__CX51__)
extern void cfg_write_bytes_code(void CYCODE *table);
extern void cfg_write_bytes(void CYFAR *table);
#else
/* For 32-bit little-endian architectures */
static void cfg_write_bytes32(void)
{
	unsigned int i, j = 0;
	for (i = 0; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = cy_cfg_addr_table[i];
		uint8 count = baseAddr & 0xFFu;
		baseAddr &= 0xFFFFFF00u;
		while (count--)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + cy_cfg_data_table[j].offset), cy_cfg_data_table[j].value);
			j++;
		}
	}
}
#endif

static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;

	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x1C0005);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x180005);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_CLKDIST_ACFG0_CFG0), (void CYCODE *)(BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL), 4);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_SLOWCLK_ILO_CR0), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x08);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_FASTCLK_IMO_CR), 0x03);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8(CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x08);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	pllLock = 0;
	for (timeout = 304; *timeout_p && (pllLock != 0x03u); timeout--) { pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_XTND_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0)); }
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0103);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_LD), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_DLY1), 0x04);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG2), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG2) | 0x03)));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG1), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG1) | 0x01)));
}

/* Analog API Functions */
void AnalogSetDefault(void)
{
	CY_SET_XTND_REG8(CYREG_PRT0_AG, 0x04);
	CY_SET_XTND_REG8(CYREG_DSM0_SW0, 0x40);
	CY_SET_XTND_REG8(CYREG_PUMP_CR0, 0x44);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
uint8 CYXDATA * const CYCODE ADC_DelSig_AMux__addrTable[] = {
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
};

const uint8 CYCODE ADC_DelSig_AMux__maskTable[] = {
	0x40, 
	0x40, 
};

void ADC_DelSig_AMux_Set(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_AMux__addrTable[channel] |= ADC_DelSig_AMux__maskTable[channel];
}

void ADC_DelSig_AMux_Unset(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_AMux__addrTable[channel] &= ~ADC_DelSig_AMux__maskTable[channel];
}


/* This function is called by the start-up code for the selected device. */
void cyfitter_cfg(void)
{
	uint8 CYDATA i;

#ifdef CYGlobalIntDisable
	CYGlobalIntDisable;
#endif

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x40 : 0x41));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_ANAIF_CFG_MISC_CR0), 0x01);

	CY_SET_XTND_REG8(CYREG_MLOGIC_DBG_DBE, (CY_GET_XTND_REG8(CYREG_MLOGIC_DBG_DBE) | 0x01));
	for (i = 0; i < CFG_MEMSET_COUNT; i++)
	{
		const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
		CYMEMZERO(ms->address, ms->size);
	}

	for (i = 0; i < CFG_MEMCPY_COUNT; i++)
	{
		const cfg_memcpy_t CYCODE * CYDATA mc = &cfg_memcpy_list[i];
		void * CYDATA dest = mc->dest;
		const void CYCODE * CYDATA src = mc->src;
		uint16 CYDATA size = mc->size;
		CYCONFIGCPYCODE(dest, src, size);
	}

	cfg_write_bytes32();

	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), 7);
	CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), (void CYCODE *)(BS_IOPORT_4_VAL), 7);
	CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), (void CYCODE *)(BS_IOPORT_5_VAL), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7);
	/* BYTES WRITTEN: 62 */

	/* Enable digital routing */
	CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
	CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

	/* Enable UDB array */
	CY_SET_XTND_REG8(CYREG_PM_ACT_CFG0, CY_GET_XTND_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
	CY_SET_XTND_REG8(CYREG_PM_AVAIL_CR2, CY_GET_XTND_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);

	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (void CYCODE *)(BS_IOPINS0_0_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (void CYCODE *)(BS_IOPINS0_2_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT4_DM0), (void CYCODE *)(BS_IOPINS0_4_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT5_DM0), (void CYCODE *)(BS_IOPINS0_5_VAL), 8);
	/* BYTES WRITTEN: 32 */

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x00 : 0x01));
	ClockSetup();
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x80 : 0x81));

	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 12);
	CY_SET_XTND_REG8(CYREG_PM_STBY_CFG0, CY_GET_XTND_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
